=== debian/changelog ===
eccodes (2.10.0-2) unstable; urgency=medium

  * Rebuild with dh-fortran-mod 0.7 for postrm script error.

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 21 Dec 2018 06:58:43 +0000

eccodes (2.10.0-1) unstable; urgency=medium

  * New upstream release
  * Drop call to dpkg-parsechangelog in d/rules
  * Use dh-fortran-mod >= 0.5, with Fortran-Mod

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 19 Dec 2018 07:26:15 +0000

eccodes (2.9.2-4) unstable; urgency=medium

  * Remove links to eccodes_memfs, too. Closes: #915014

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 29 Nov 2018 16:04:28 +0000

eccodes (2.9.2-3) unstable; urgency=medium

  * Disable MEMFS usage to pick up defs changes

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 19 Nov 2018 13:05:13 +0000

eccodes (2.9.2-2) unstable; urgency=medium

  * Don't use hard-coded python. Closes: #913270

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 14 Nov 2018 12:00:29 +0000

eccodes (2.9.2-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 13 Nov 2018 07:05:48 +0000

eccodes (2.9.0-1) unstable; urgency=medium

  * New upstream release
  * Undo hard-coded gfortran-8; now the default
  * Update URLs in debian/watch
  * Standards-Version: 4.2.1
  * Drop hard-coded xz compression in d/source/options

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 30 Sep 2018 12:43:23 +0100
